/*
EntryPoints

## Overview  EntryPoint is one of the ways to start interaction flow. It can be represented as QR code, link (https://slace.me/... URL) or NFC tag.  ## Data  EntryPoints contain two types of data:   - **static** - *\"internal\" data storage which can be updated only via editing the EntryPoint* (directly or via Interaction) - **dynamic** - *public data which can be altered also via query parameters of the EP link. Should NOT be used for secrets or critical data* because it can be overwritten by the end user.  Both data containers are copied to transaction created when EntryPoint is entered. This data is used primarily for personalization or flow control of the Interaction.  ## EP Batches  EntryPoints can be batch-created (superadmin feature) and then [assigned](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx) to specific Interactions.  > EntryPoints in a batch have random hashes but it's possible to mass-create EPs using the assignment feature (only superadmins). If a value from **Link hash** column is not found it will be auto-created. This allows to create EntryPoints following different hash pattern (e.g. with common prefix).  EntryPoints are re-assignable meaning that they can be re-used for other Interactions even in another Channel or Organization by another [assignment import](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx).  ## Redirects  There is a special type of EntryPoint which does not start a SLACE Interaction but redirects to a configured URL.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package entrypoints

import (
	"encoding/json"
)

// checks if the AdminEntryPointNewData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AdminEntryPointNewData{}

// AdminEntryPointNewData struct for AdminEntryPointNewData
type AdminEntryPointNewData struct {
	Type AdminEntryPointType `json:"type"`
	OrganizationId string `json:"organization_id"`
	// required if type != external
	ChannelId *string `json:"channel_id,omitempty"`
	// required if type == interaction
	InteractionId *string `json:"interaction_id,omitempty"`
	// required if type == external
	Url *string `json:"url,omitempty"`
	// required if type == campaign
	MessageLinkHash *string `json:"message_link_hash,omitempty"`
	// Optional url to which entry point will redirect when expired
	ExpiredUrl *string `json:"expired_url,omitempty"`
	// time to live in seconds
	Ttl *int32 `json:"ttl,omitempty"`
	Params *map[string]string `json:"params,omitempty"`
	Data *map[string]string `json:"data,omitempty"`
	// Any text without '.' characters. Preferred over interaction_id if keeping the reference to the latest version of interaction is required.
	CustomerExperienceId *string `json:"customer_experience_id,omitempty"`
	// Custom entry point hash
	Hash *string `json:"hash,omitempty"`
	HashPrefix *string `json:"hash_prefix,omitempty"`
	HashLength *int32 `json:"hash_length,omitempty"`
}

// NewAdminEntryPointNewData instantiates a new AdminEntryPointNewData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAdminEntryPointNewData(type_ AdminEntryPointType, organizationId string) *AdminEntryPointNewData {
	this := AdminEntryPointNewData{}
	this.Type = type_
	this.OrganizationId = organizationId
	return &this
}

// NewAdminEntryPointNewDataWithDefaults instantiates a new AdminEntryPointNewData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAdminEntryPointNewDataWithDefaults() *AdminEntryPointNewData {
	this := AdminEntryPointNewData{}
	return &this
}

// GetType returns the Type field value
func (o *AdminEntryPointNewData) GetType() AdminEntryPointType {
	if o == nil {
		var ret AdminEntryPointType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetTypeOk() (*AdminEntryPointType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *AdminEntryPointNewData) SetType(v AdminEntryPointType) {
	o.Type = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *AdminEntryPointNewData) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *AdminEntryPointNewData) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *AdminEntryPointNewData) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *AdminEntryPointNewData) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *AdminEntryPointNewData) SetUrl(v string) {
	o.Url = &v
}

// GetMessageLinkHash returns the MessageLinkHash field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetMessageLinkHash() string {
	if o == nil || IsNil(o.MessageLinkHash) {
		var ret string
		return ret
	}
	return *o.MessageLinkHash
}

// GetMessageLinkHashOk returns a tuple with the MessageLinkHash field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetMessageLinkHashOk() (*string, bool) {
	if o == nil || IsNil(o.MessageLinkHash) {
		return nil, false
	}
	return o.MessageLinkHash, true
}

// HasMessageLinkHash returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasMessageLinkHash() bool {
	if o != nil && !IsNil(o.MessageLinkHash) {
		return true
	}

	return false
}

// SetMessageLinkHash gets a reference to the given string and assigns it to the MessageLinkHash field.
func (o *AdminEntryPointNewData) SetMessageLinkHash(v string) {
	o.MessageLinkHash = &v
}

// GetExpiredUrl returns the ExpiredUrl field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetExpiredUrl() string {
	if o == nil || IsNil(o.ExpiredUrl) {
		var ret string
		return ret
	}
	return *o.ExpiredUrl
}

// GetExpiredUrlOk returns a tuple with the ExpiredUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetExpiredUrlOk() (*string, bool) {
	if o == nil || IsNil(o.ExpiredUrl) {
		return nil, false
	}
	return o.ExpiredUrl, true
}

// HasExpiredUrl returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasExpiredUrl() bool {
	if o != nil && !IsNil(o.ExpiredUrl) {
		return true
	}

	return false
}

// SetExpiredUrl gets a reference to the given string and assigns it to the ExpiredUrl field.
func (o *AdminEntryPointNewData) SetExpiredUrl(v string) {
	o.ExpiredUrl = &v
}

// GetTtl returns the Ttl field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetTtl() int32 {
	if o == nil || IsNil(o.Ttl) {
		var ret int32
		return ret
	}
	return *o.Ttl
}

// GetTtlOk returns a tuple with the Ttl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetTtlOk() (*int32, bool) {
	if o == nil || IsNil(o.Ttl) {
		return nil, false
	}
	return o.Ttl, true
}

// HasTtl returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasTtl() bool {
	if o != nil && !IsNil(o.Ttl) {
		return true
	}

	return false
}

// SetTtl gets a reference to the given int32 and assigns it to the Ttl field.
func (o *AdminEntryPointNewData) SetTtl(v int32) {
	o.Ttl = &v
}

// GetParams returns the Params field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetParams() map[string]string {
	if o == nil || IsNil(o.Params) {
		var ret map[string]string
		return ret
	}
	return *o.Params
}

// GetParamsOk returns a tuple with the Params field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetParamsOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Params) {
		return nil, false
	}
	return o.Params, true
}

// HasParams returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasParams() bool {
	if o != nil && !IsNil(o.Params) {
		return true
	}

	return false
}

// SetParams gets a reference to the given map[string]string and assigns it to the Params field.
func (o *AdminEntryPointNewData) SetParams(v map[string]string) {
	o.Params = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetData() map[string]string {
	if o == nil || IsNil(o.Data) {
		var ret map[string]string
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetDataOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given map[string]string and assigns it to the Data field.
func (o *AdminEntryPointNewData) SetData(v map[string]string) {
	o.Data = &v
}

// GetCustomerExperienceId returns the CustomerExperienceId field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetCustomerExperienceId() string {
	if o == nil || IsNil(o.CustomerExperienceId) {
		var ret string
		return ret
	}
	return *o.CustomerExperienceId
}

// GetCustomerExperienceIdOk returns a tuple with the CustomerExperienceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetCustomerExperienceIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerExperienceId) {
		return nil, false
	}
	return o.CustomerExperienceId, true
}

// HasCustomerExperienceId returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasCustomerExperienceId() bool {
	if o != nil && !IsNil(o.CustomerExperienceId) {
		return true
	}

	return false
}

// SetCustomerExperienceId gets a reference to the given string and assigns it to the CustomerExperienceId field.
func (o *AdminEntryPointNewData) SetCustomerExperienceId(v string) {
	o.CustomerExperienceId = &v
}

// GetHash returns the Hash field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetHash() string {
	if o == nil || IsNil(o.Hash) {
		var ret string
		return ret
	}
	return *o.Hash
}

// GetHashOk returns a tuple with the Hash field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetHashOk() (*string, bool) {
	if o == nil || IsNil(o.Hash) {
		return nil, false
	}
	return o.Hash, true
}

// HasHash returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasHash() bool {
	if o != nil && !IsNil(o.Hash) {
		return true
	}

	return false
}

// SetHash gets a reference to the given string and assigns it to the Hash field.
func (o *AdminEntryPointNewData) SetHash(v string) {
	o.Hash = &v
}

// GetHashPrefix returns the HashPrefix field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetHashPrefix() string {
	if o == nil || IsNil(o.HashPrefix) {
		var ret string
		return ret
	}
	return *o.HashPrefix
}

// GetHashPrefixOk returns a tuple with the HashPrefix field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetHashPrefixOk() (*string, bool) {
	if o == nil || IsNil(o.HashPrefix) {
		return nil, false
	}
	return o.HashPrefix, true
}

// HasHashPrefix returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasHashPrefix() bool {
	if o != nil && !IsNil(o.HashPrefix) {
		return true
	}

	return false
}

// SetHashPrefix gets a reference to the given string and assigns it to the HashPrefix field.
func (o *AdminEntryPointNewData) SetHashPrefix(v string) {
	o.HashPrefix = &v
}

// GetHashLength returns the HashLength field value if set, zero value otherwise.
func (o *AdminEntryPointNewData) GetHashLength() int32 {
	if o == nil || IsNil(o.HashLength) {
		var ret int32
		return ret
	}
	return *o.HashLength
}

// GetHashLengthOk returns a tuple with the HashLength field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPointNewData) GetHashLengthOk() (*int32, bool) {
	if o == nil || IsNil(o.HashLength) {
		return nil, false
	}
	return o.HashLength, true
}

// HasHashLength returns a boolean if a field has been set.
func (o *AdminEntryPointNewData) HasHashLength() bool {
	if o != nil && !IsNil(o.HashLength) {
		return true
	}

	return false
}

// SetHashLength gets a reference to the given int32 and assigns it to the HashLength field.
func (o *AdminEntryPointNewData) SetHashLength(v int32) {
	o.HashLength = &v
}

func (o AdminEntryPointNewData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AdminEntryPointNewData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	toSerialize["organization_id"] = o.OrganizationId
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	if !IsNil(o.MessageLinkHash) {
		toSerialize["message_link_hash"] = o.MessageLinkHash
	}
	if !IsNil(o.ExpiredUrl) {
		toSerialize["expired_url"] = o.ExpiredUrl
	}
	if !IsNil(o.Ttl) {
		toSerialize["ttl"] = o.Ttl
	}
	if !IsNil(o.Params) {
		toSerialize["params"] = o.Params
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	if !IsNil(o.CustomerExperienceId) {
		toSerialize["customer_experience_id"] = o.CustomerExperienceId
	}
	if !IsNil(o.Hash) {
		toSerialize["hash"] = o.Hash
	}
	if !IsNil(o.HashPrefix) {
		toSerialize["hash_prefix"] = o.HashPrefix
	}
	if !IsNil(o.HashLength) {
		toSerialize["hash_length"] = o.HashLength
	}
	return toSerialize, nil
}

type NullableAdminEntryPointNewData struct {
	value *AdminEntryPointNewData
	isSet bool
}

func (v NullableAdminEntryPointNewData) Get() *AdminEntryPointNewData {
	return v.value
}

func (v *NullableAdminEntryPointNewData) Set(val *AdminEntryPointNewData) {
	v.value = val
	v.isSet = true
}

func (v NullableAdminEntryPointNewData) IsSet() bool {
	return v.isSet
}

func (v *NullableAdminEntryPointNewData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAdminEntryPointNewData(val *AdminEntryPointNewData) *NullableAdminEntryPointNewData {
	return &NullableAdminEntryPointNewData{value: val, isSet: true}
}

func (v NullableAdminEntryPointNewData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAdminEntryPointNewData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


